/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.SceneManager
 *  fire.pb.map.Transfer
 *  fire.pb.mission.SFairylandStatus
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.MapUtil
 *  fire.pb.util.MessageUtil
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.RolePos
 *  xtable.Roleposes
 */
package fire.pb.mission.fairyland;

import fire.pb.PropRole;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.SceneManager;
import fire.pb.map.Transfer;
import fire.pb.mission.SFairylandStatus;
import fire.pb.mission.fairyland.FairylandMgr;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.MapUtil;
import fire.pb.util.MessageUtil;
import java.util.ArrayList;
import java.util.List;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.Pod;
import xbean.RolePos;
import xtable.Roleposes;

public class PEnterFairyland
extends Procedure {
    private int mapid;
    private int posx;
    private int posy;
    private boolean playCG;
    long roleid;
    private boolean isLeader;

    public PEnterFairyland(long roleid, int mapid, int posx, int posy, boolean playCG, boolean isLeader) {
        this.roleid = roleid;
        this.mapid = mapid;
        this.posx = posx;
        this.posy = posy;
        this.playCG = playCG;
        this.isLeader = isLeader;
    }

    protected boolean process() throws Exception {
        Team team = TeamManager.getTeamByRoleId((long)this.roleid);
        this.saveDynamicMapPos();
        if (!Transfer.canChangeMap((long)this.roleid, (int)(this.playCG ? 516018 : 516022), (int)this.mapid)) {
            return true;
        }
        if (team != null && !team.isTeamLeader(this.roleid)) {
            MessageMgr.psendMsgNotify((long)this.roleid, (int)144846, (int)0, null);
            return true;
        }
        Role role = RoleManager.getInstance().getRoleByID(this.roleid);
        if (role == null) {
            return true;
        }
        if (!FairylandMgr.isInDreamMap(role.getScene())) {
            int roleMap = MapUtil.getBaseMapIdBySceneId((long)role.getScene());
            int positionx = role.getPos().toGridPos().getX();
            int positiony = role.getPos().toGridPos().getY();
            this.saveOriginalPos(this.roleid, roleMap, positionx, positiony);
        }
        List<Long> roleids = null;
        if (TeamManager.isTeamLeader((long)this.roleid)) {
            roleids = TeamManager.getTeamByRoleId((long)this.roleid).getNormalMemberIds();
        } else {
            roleids = new ArrayList();
            roleids.add(this.roleid);
        }
        for (Long rid : roleids) {
            RolePos rolePos = Roleposes.get((Long)rid);
            if (rolePos == null) {
                rolePos = Pod.newRolePos();
                Roleposes.insert((Long)rid, (RolePos)rolePos);
            }
            rolePos.setOwnerid(this.roleid);
            SFairylandStatus sds = new SFairylandStatus(2);
            PEnterFairyland.psendWhileCommit((long)rid, (Protocol)sds);
        }
        String mapName = SceneManager.getMapNameByMapID((int)this.mapid);
        Transfer.justGotoWhileCommit((long)this.roleid, (long)this.mapid, (int)this.posx, (int)this.posy, (int)(this.playCG ? 516018 : 516022));
        String leaderName = new PropRole(this.roleid, true).getName();
        List paras = MessageUtil.getMsgParaList((String[])new String[]{leaderName, mapName});
        for (Long rid : roleids) {
            if (rid == this.roleid) {
                MessageMgr.psendMsgNotifyWhileCommit((long)rid, (int)142065, (List)MessageUtil.getMsgParaList((String[])new String[]{mapName}));
                continue;
            }
            MessageMgr.psendMsgNotifyWhileCommit((long)rid, (int)142066, (List)paras);
        }
        return true;
    }

    private void saveDynamicMapPos() {
        RolePos rolePos = Roleposes.get((Long)this.roleid);
        if (rolePos == null) {
            rolePos = Pod.newRolePos();
            Roleposes.insert((Long)this.roleid, (RolePos)rolePos);
        }
        rolePos.setDynamicmap(this.mapid);
        rolePos.setDynamicposx(this.posx);
        rolePos.setDynamicposy(this.posy);
    }

    private void saveOriginalPos(long roleid, int roleMap, int posx, int posy) {
        List<Long> roleids = null;
        if (TeamManager.isTeamLeader((long)roleid)) {
            Team team = TeamManager.getTeamByRoleId((long)roleid);
            if (team != null) {
                roleids = team.getNormalMemberIds();
            } else {
                roleids = new ArrayList();
                roleids.add(roleid);
            }
        } else {
            roleids = new ArrayList<Long>();
            roleids.add(roleid);
        }
        for (Long rid : roleids) {
            RolePos rolePos = Roleposes.get((Long)rid);
            if (rolePos == null) {
                rolePos = Pod.newRolePos();
                Roleposes.insert((Long)rid, (RolePos)rolePos);
            }
            rolePos.setStatus(2);
            rolePos.setMapid(roleMap);
            rolePos.setPosx(posx);
            rolePos.setPosy(posy);
        }
    }
}

